from machine import Pin,UART, PWM
import time
from time import sleep
import random

uart = UART(1, baudrate=115200, tx=Pin(4), rx=Pin(5))
uart.init(bits=8, parity=None, stop=1)
led = Pin("LED", Pin.OUT)

ledR = machine.Pin(0)
ledG = machine.Pin(1)
ledB = machine.Pin(2)

led_pwm_red = PWM(ledR)
led_pwm_green = PWM(ledG)
led_pwm_blue = PWM(ledB)

duty_step = 13107  # 65535/5 = 13107  

#Set PWM frequency
frequency = 1000
led_pwm_red.freq (frequency)
led_pwm_green.freq (frequency)
led_pwm_blue.freq (frequency)

duty_cycle=1
led_pwm_red.duty_u16(duty_cycle)
led_pwm_green.duty_u16(duty_cycle)
led_pwm_blue.duty_u16(duty_cycle)

random_flag =0
color_set =0
intensity =1

uart.write('ETC22 RGB lamp\r\n')   # write something

while True:
    if uart.any(): 
        data = uart.read() 
        if data== b'a':		#next color settimg
            color_set +=1
            if color_set >6:
                color_set =0
            uart.write('Color '+str(color_set)+'\r\n')   # write something
            
        elif data== b'b':		#previous color setting
            color_set -=1
            if color_set <0:
                color_set =6
            uart.write('Color '+str(color_set)+'\r\n')   # write something
            
        elif data== b'c':		#higher intensity
            intensity +=1
            if intensity >5:
                intensity =5
            uart.write('Light '+str(intensity)+'\r\n')   # write something
            
        elif data== b'd':		#lower intensity
            intensity -=1
            if intensity <0:
                intensity =0
            uart.write('Light '+str(intensity)+'\r\n')   # write something
            
        elif data== b'e':	#random colors
            if random_flag:
                random_flag =0
                uart.write('Random OFF\r\n')   # write something
            else:
                random_flag =1
                uart.write('Random ON\r\n')   # write something
            
    if random_flag==1:
        min=10
        max=65535
        led_pwm_red.duty_u16(random.randint(min, max))
        led_pwm_green.duty_u16(random.randint(min, max))
        led_pwm_blue.duty_u16(random.randint(min, max))
    else:
        if color_set ==0:
            led_pwm_red.duty_u16(duty_step*intensity)
            led_pwm_green.duty_u16(0)
            led_pwm_blue.duty_u16(0)
        elif color_set ==1:
            led_pwm_red.duty_u16(0)
            led_pwm_green.duty_u16(duty_step*intensity)
            led_pwm_blue.duty_u16(0)
        elif color_set ==2:
            led_pwm_red.duty_u16(0)
            led_pwm_green.duty_u16(0)
            led_pwm_blue.duty_u16(duty_step*intensity)
        elif color_set ==3:
            led_pwm_red.duty_u16(duty_step*intensity)
            led_pwm_green.duty_u16(0)
            led_pwm_blue.duty_u16(duty_step*intensity)
        elif color_set ==4:
            led_pwm_red.duty_u16(duty_step*intensity)
            led_pwm_green.duty_u16(duty_step*intensity)
            led_pwm_blue.duty_u16(0)
        elif color_set ==5:
            led_pwm_red.duty_u16(0)
            led_pwm_green.duty_u16(duty_step*intensity)
            led_pwm_blue.duty_u16(duty_step*intensity)
        elif color_set ==6:
            led_pwm_red.duty_u16(duty_step*intensity)
            led_pwm_green.duty_u16(duty_step*intensity)
            led_pwm_blue.duty_u16(duty_step*intensity)
        
    time.sleep(0.1)
    led.toggle()